commit 3f3bb9375a7551a4118a0eae56c8bb642f5bae54
Author: Olga Brani <olgabrani@grnet.gr>
Date:   Tue Nov 5 18:21:31 2013 +0200

    new ui: clean up data-reveal modal in vm-list

diff --git a/snf-cyclades-app/synnefo/ui/new_ui/ui/vm_list.html b/snf-cyclades-app/synnefo/ui/new_ui/ui/vm_list.html
index 502768d..8729f8f 100644
--- a/snf-cyclades-app/synnefo/ui/new_ui/ui/vm_list.html
+++ b/snf-cyclades-app/synnefo/ui/new_ui/ui/vm_list.html
@@ -764,7 +764,7 @@ Confirm that the options you have selected are correct</p>
 						</div>
 					</li>
 					<li data-status="building">
-					<a href="" class="btn5 temp">animation</a>
+						<a href="" class="btn5 temp">animation</a>
 						<div class="more">
 							<div class="clearfix">
 								<div class="col lt">
@@ -778,7 +778,7 @@ Confirm that the options you have selected are correct</p>
 								</div>
 								<div class="col rt">
 									<ul>
-										<li><a href="">Connect</a></li>
+										<li><a href="" data-reveal-id="vm-connect">Connect</a></li>
 										<li><a href="">Details</a></li>
 									</ul>
 								</div>
@@ -788,9 +788,9 @@ Confirm that the options you have selected are correct</p>
 						<div class="container">
 							<div class="img-wrap">
 								<div class="img running">
-									<span class="snf-PC_fill incomplete" data-reveal-id="vm-connect"></span>
-									<span class="snf-PC_fill complete" data-reveal-id="vm-connect"></span>
-									<span class="os" data-reveal-id="vm-connect">unknown</span>
+									<span class="snf-PC_fill incomplete"></span>
+									<span class="snf-PC_fill complete"></span>
+									<span class="os">unknown</span>
 								</div>
 							</div>
 							<h4>vm name 1 really large name vm name vm 1 really large name vm</h4>
@@ -816,7 +816,7 @@ Confirm that the options you have selected are correct</p>
 								</div>
 								<div class="col rt">
 									<ul>
-										<li><a href="">Connect</a></li>
+										<li><a href="" data-reveal-id="vm-connect">Connect</a></li>
 										<li><a href="">Details</a></li>
 									</ul>
 								</div>
@@ -826,8 +826,8 @@ Confirm that the options you have selected are correct</p>
 						<div class="container">
 							<div class="img-wrap">
 								<div class="img running">
-									<span class="snf-PC_fill" data-reveal-id="vm-connect"></span>
-									<span class="os" data-reveal-id="vm-connect">unknown</span>
+									<span class="snf-PC_fill"></span>
+									<span class="os">unknown</span>
 								</div>
 							</div>
 							<h4>short name</h4>
@@ -853,7 +853,7 @@ Confirm that the options you have selected are correct</p>
 								</div>
 								<div class="col rt">
 									<ul>
-										<li><a href="">Connect</a></li>
+										<li><a href="" data-reveal-id="vm-connect">Connect</a></li>
 										<li><a href="">Details</a></li>
 									</ul>
 								</div>
@@ -863,8 +863,8 @@ Confirm that the options you have selected are correct</p>
 						<div class="container">
 							<div class="img-wrap">
 								<div class="img running">
-									<span class="snf-PC_fill" data-reveal-id="vm-connect"></span>
-									<span class="os fedora" data-reveal-id="vm-connect">fedora</span>
+									<span class="snf-PC_fill"></span>
+									<span class="os fedora">fedora</span>
 								</div>
 							</div>
 							<h4>vm name 1 really large name vm name vm 1 really large name vm</h4>
@@ -888,7 +888,7 @@ Confirm that the options you have selected are correct</p>
 								</div>
 								<div class="col rt">
 									<ul>
-										<li><a href="">Connect</a></li>
+										<li><a href="" data-reveal-id="vm-connect">Connect</a></li>
 										<li><a href="">Details</a></li>
 									</ul>
 								</div>
@@ -898,8 +898,8 @@ Confirm that the options you have selected are correct</p>
 						<div class="container">
 							<div class="img-wrap">
 								<div class="img running">
-									<span class="snf-PC_fill" data-reveal-id="vm-connect"></span>
-									<span class="os kubuntu" data-reveal-id="vm-connect">kubuntu</span>
+									<span class="snf-PC_fill"></span>
+									<span class="os kubuntu">kubuntu</span>
 								</div>
 							</div>
 							<h4>vm name 1 really large name vm name vm 1 really large name vm</h4>
@@ -926,7 +926,7 @@ Confirm that the options you have selected are correct</p>
 								</div>
 								<div class="col rt">
 									<ul>
-										<li><a href="">Connect</a></li>
+										<li><a href="" data-reveal-id="vm-connect">Connect</a></li>
 										<li><a href="">Details</a></li>
 									</ul>
 								</div>
@@ -936,8 +936,8 @@ Confirm that the options you have selected are correct</p>
 						<div class="container">
 							<div class="img-wrap">
 								<div class="img running">
-									<span class="snf-PC_fill" data-reveal-id="vm-connect"></span>
-									<span class="os kubuntu" data-reveal-id="vm-connect">kubuntu</span>
+									<span class="snf-PC_fill"></span>
+									<span class="os kubuntu">kubuntu</span>
 								</div>
 							</div>
 							<h4>vm name 1 really large name vm name vm 1 really large name vm</h4>
@@ -962,7 +962,7 @@ Confirm that the options you have selected are correct</p>
 								</div>
 								<div class="col rt">
 									<ul>
-										<li><a href="">Connect</a></li>
+										<li><a href="" data-reveal-id="vm-connect">Connect</a></li>
 										<li><a href="">Details</a></li>
 									</ul>
 								</div>
@@ -972,8 +972,8 @@ Confirm that the options you have selected are correct</p>
 						<div class="container">
 							<div class="img-wrap">
 								<div class="img running">
-									<span class="snf-PC_fill" data-reveal-id="vm-connect"></span>
-									<span class="os kubuntu" data-reveal-id="vm-connect">kubuntu</span>
+									<span class="snf-PC_fill"></span>
+									<span class="os kubuntu">kubuntu</span>
 								</div>
 							</div>
 							<h4>short name</h4>
@@ -1000,7 +1000,7 @@ Confirm that the options you have selected are correct</p>
 								</div>
 								<div class="col rt">
 									<ul>
-										<li><a href="">Connect</a></li>
+										<li><a href="" data-reveal-id="vm-connect">Connect</a></li>
 										<li><a href="">Details</a></li>
 									</ul>
 								</div>
@@ -1010,8 +1010,8 @@ Confirm that the options you have selected are correct</p>
 						<div class="container">
 							<div class="img-wrap">
 								<div class="img running">
-									<span class="snf-PC_fill" data-reveal-id="vm-connect"></span>
-									<span class="os kubuntu" data-reveal-id="vm-connect">kubuntu</span>
+									<span class="snf-PC_fill"></span>
+									<span class="os kubuntu">kubuntu</span>
 								</div>
 							</div>
 							<h4>short name</h4>
@@ -1034,7 +1034,7 @@ Confirm that the options you have selected are correct</p>
 								</div>
 								<div class="col rt">
 									<ul>
-										<li><a href="">Connect</a></li>
+										<li><a href="" data-reveal-id="vm-connect">Connect</a></li>
 										<li><a href="">Details</a></li>
 									</ul>
 								</div>
@@ -1044,8 +1044,8 @@ Confirm that the options you have selected are correct</p>
 						<div class="container">
 							<div class="img-wrap">
 								<div class="img running">
-									<span class="snf-PC_fill" data-reveal-id="vm-connect"></span>
-									<span class="os fedora" data-reveal-id="vm-connect">fedora</span>
+									<span class="snf-PC_fill"></span>
+									<span class="os fedora">fedora</span>
 								</div>
 							</div>
 							<h4>short name</h4>
@@ -1069,7 +1069,7 @@ Confirm that the options you have selected are correct</p>
 								</div>
 								<div class="col rt">
 									<ul>
-										<li><a href="">Connect</a></li>
+										<li><a href="" data-reveal-id="vm-connect">Connect</a></li>
 										<li><a href="">Details</a></li>
 									</ul>
 								</div>
@@ -1105,7 +1105,7 @@ Confirm that the options you have selected are correct</p>
 								</div>
 								<div class="col rt">
 									<ul>
-										<li><a href="">Connect</a></li>
+										<li><a href="" data-reveal-id="vm-connect">Connect</a></li>
 										<li><a href="">Details</a></li>
 									</ul>
 								</div>